//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.h>
#pragma hdrstop

#define ALM0 1e-10
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TEdit *Eda[10],*Edz[8],*Edfz[8];
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Form1->Top=(Screen->Height-Form1->Height)/2;
	Form1->Left=(Screen->Width-Form1->Width)/2;
	Edz[3]=Editz4r;
    Edz[2]=Editz3r;
    Edz[1]=Editz2r;
    Edz[0]=Editz1r;
	Edz[7]=Editz4i;
    Edz[6]=Editz3i;
    Edz[5]=Editz2i;
    Edz[4]=Editz1i;

	Edfz[3]=Editfz4r;
    Edfz[2]=Editfz3r;
    Edfz[1]=Editfz2r;
    Edfz[0]=Editfz1r;
	Edfz[7]=Editfz4i;
    Edfz[6]=Editfz3i;
    Edfz[5]=Editfz2i;
    Edfz[4]=Editfz1i;

	Eda[0]=Edita4r;
    Eda[1]=Edita3r;
    Eda[2]=Edita2r;
    Eda[3]=Edita1r;
    Eda[4]=Edita0r;
	Eda[5]=Edita4i;
    Eda[6]=Edita3i;
    Eda[7]=Edita2i;
    Eda[8]=Edita1i;
    Eda[9]=Edita0i;

    randomize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::zClear()
{
	for(int i=0;i<8;i++){
        Edz[i]->Text="";
	    Edfz[i]->Text="";
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	for(int i=0;i<10;i++) Eda[i]->Text="";
	zClear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	double s[10];
	for(int i=0;i<10;i++){
    	if(Eda[i]->Text=="") s[i]=0;
    	else s[i]=Eda[i]->Text.ToDouble();
    }

	complex a[5],z[4],b[5];
	for(int i=0;i<5;i++) a[4-i]=b[4-i]=complex(s[i],s[i+5]);

	zClear();

    int j=4,jj=0;
	while(a[j]==0) j--;


	if(j==4){
        if(b[0]==0){
            b[0]=b[1];
            b[1]=b[2];
            b[2]=b[3];
            b[3]=b[4];
            Edz[3]->Text=0;
            Edz[7]->Text=0;
            Edfz[3]->Text=0;
            Edfz[7]->Text=0;
            jj++;
        }else sol4(b,z);
    }
	if(j-jj==3){
        if(b[0]==0){
            b[0]=b[1];
            b[1]=b[2];
            b[2]=b[3];
            Edz[2]->Text=0;
            Edz[6]->Text=0;
            Edfz[2]->Text=0;
            Edfz[6]->Text=0;
            jj++;
        }else sol3(b,z);
    }
	if(j-jj==2){
        if(b[0]==0){
            b[0]=b[1];
            b[1]=b[2];
            Edz[1]->Text=0;
            Edz[5]->Text=0;
            Edfz[1]->Text=0;
            Edfz[5]->Text=0;
            jj++;
        }else sol2(b,z);
    }
	if(j-jj==1) z[0]=-b[0]/b[1];
	if(j<=0){
        Application->MessageBox("Trivial Problem.","Alert",MB_OK);
        return;
    }

    for(int i=0;i<j;i++){
        double zr=real(z[i]),zi=imag(z[i]);

        if(norm(a[j])>ALM0){
            if(fabs(zr/norm(a[j]))<ALM0) zr=0;
            if(fabs(zi/norm(a[j]))<ALM0) zi=0;
        }
    	Edz[i]->Text=zr;
        Edz[i+4]->Text=zi;

        complex fz=cpoly4(a,z[i]);

        zr=real(fz),zi=imag(fz);
        if(norm(a[j])>ALM0){
            if(fabs(zr/norm(a[j]))<ALM0) zr=0;
            if(fabs(zi/norm(a[j]))<ALM0) zi=0;
        }
    	Edfz[i]->Text=zr;
        Edfz[i+4]->Text=zi;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sol2(complex xa[],complex xz[])
{
	complex cx=csqrt(xa[1]*xa[1]-4*xa[2]*xa[0]);

    xz[0]=(-xa[1]+cx)/(2*xa[2]);
    xz[1]=(-xa[1]-cx)/(2*xa[2]);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::sol3(complex xa[],complex xz[])
{
	complex p,q,b[3];

	b[0]=xa[0]/xa[3];
	b[1]=xa[1]/xa[3];
	b[2]=xa[2]/xa[3];

    p=(3.0*b[1]-b[2]*b[2])/9.0;
    q=(2.0*b[2]*b[2]*b[2]-9.0*b[2]*b[1]+27.0*b[0])/27.0;

    complex cx,ct1,ct2;
    cx=csqrt(q*q+4.0*p*p*p);


	ct1=ccbrt(0.5*(-q+cx));

    if(norm(ct1)>ALM0*ALM0) ct2=-p/ct1;
    else{
        ct2=ccbrt(0.5*(-q-cx));
        if(norm(ct2)>ALM0*ALM0) ct1=-p/ct2;
        else ct1=ct2=0;
    }
    if(norm(cx+q)<ALM0*norm(cx)){
        ct1=ccbrt(0.5*(-q+cx));
        ct2=-p/ct1;
    }
    if(norm(cx-q)<ALM0*norm(cx)){
        ct2=ccbrt(0.5*(-q-cx));
        ct1=-p/ct2;
    }


   	complex w1=complex(-0.5,0.5*sqrt(3.0)),w2=complex(-0.5,-0.5*sqrt(3.0));

    xz[0]=ct1+ct2-b[2]/3.0;
    xz[1]=ct1*w1+ct2*w2-b[2]/3.0;
    xz[2]=ct1*w2+ct2*w1-b[2]/3.0;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::sol4(complex xa[],complex xz[])
{
	complex p,q,r,b[4],p3,q3,cb[4],cz[3];

	b[0]=xa[0]/xa[4];
	b[1]=xa[1]/xa[4];
	b[2]=xa[2]/xa[4];
	b[3]=xa[3]/xa[4];

    if(norm(b[1])<=ALM0*ALM0&&norm(b[3])<=ALM0*ALM0){

        cb[0]=b[0];
        cb[1]=b[2];
        cb[2]=1.0;
        sol2(cb,cz);
        xz[0]=csqrt(cz[0]);
        xz[1]=csqrt(cz[1]);
        xz[2]=-xz[0];
        xz[3]=-xz[1];
        return;

    }

    p=-3.0*b[3]*b[3]/8.0+b[2];
    q=0.5*b[3]*(0.25*b[3]*b[3]-b[2])+b[1];
    r=0.25*b[3]*(-b[1]+0.25*b[3]*(b[2]-3.0*b[3]*b[3]/16.0))+b[0];

    cb[0]=-q*q/64;
    cb[1]=(p*p-4*r)/16;
    cb[2]=0.5*p;
    cb[3]=1.0;
    sol3(cb,cz);


    complex sqt,ez[4];
    double err[3];
    int si=0;
    err[0]=1e10;

    for(int ei=0;ei<3;ei++){
        sqt=csqrt(cz[ei]);

        if(norm(sqt)>=ALM0*ALM0){
    	    p3=csqrt(-sqt*sqt-0.5*p-0.25*q/sqt);
    	    q3=csqrt(-sqt*sqt-0.5*p+0.25*q/sqt);

		    ez[0]=sqt+p3-0.25*b[3];
		    ez[1]=sqt-p3-0.25*b[3];
		    ez[2]=-sqt+q3-0.25*b[3];
		    ez[3]=-sqt-q3-0.25*b[3];
        }else ez[0]=ez[1]=ez[2]=ez[3]=-0.25*b[3];

        if(norm(b[3])>=ALM0*ALM0){
            err[ei]=norm(cpoly4(xa,ez[0]))+norm(cpoly4(xa,ez[1]))
                    +norm(cpoly4(xa,ez[2]))+norm(cpoly4(xa,ez[3]));
        }

        if(err[si]>=err[ei]){
            xz[0]=ez[0];
            xz[1]=ez[1];
            xz[2]=ez[2];
            xz[3]=ez[3];
        }

    }
}
//---------------------------------------------------------------------------
complex __fastcall TForm1::csqrt(complex xc)
{
    double cr=real(xc),ci=imag(xc);
    if(norm(xc)<ALM0*ALM0) return complex(0,0);

	double rtt=pow(cr*cr+ci*ci,0.25),th=atan2(ci,cr)*0.5;

	return complex(rtt*cos(th),rtt*sin(th));
}
//---------------------------------------------------------------------------
complex __fastcall TForm1::ccbrt(complex xc)
{
    double cr=real(xc),ci=imag(xc),rtt,th,alm2=ALM0*ALM0;
    if(norm(xc)<alm2) return complex(0,0);

    if(ci*ci<alm2){
        if(cr>=0) return complex(pow(cr,1.0/3.0),0);
        else return complex(-pow(-cr,1.0/3.0),0);
    }
    if(cr*cr<alm2){
        if(ci>=0) return complex(0,-pow(ci,1.0/3.0));
        else return complex(0,pow(-ci,1.0/3.0));
    }

    rtt=pow(cr*cr+ci*ci,1.0/6.0),th=atan2(ci,cr)/3.0;

	return complex(rtt*cos(th),rtt*sin(th));
}
//---------------------------------------------------------------------------
complex __fastcall TForm1::cpoly4(complex xa[],complex z)
{
    return xa[0]+z*(xa[1]+z*(xa[2]+z*(xa[3]+z*xa[4])));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditSW(TEdit *ed,bool xb)
{
    ed->Enabled=xb;
    if(xb) ed->Color=clWindow;
    else ed->Color=clBtnFace;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
	for(int i=5;i<10;i++){
        EditSW(Eda[i],!CheckBox1->Checked);
		Eda[i]->Text="";
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	Application->MessageBox("QEQ Ver. 1.10\n\nCopyright 2003- Tsutomu Ohmori.","Credit",MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
    FILE *op;

    op=fopen("test.txt","wt");

    for(int xi=0;xi<10000;xi++){

    if(CheckBox1->Checked){
        for(int ai=0;ai<5;ai++){
            double ax=rand()%100;
            if(rand()%2==1) ax/=rand()%100+1;
            if(rand()%2==1) ax=-ax;
            if(rand()%2==1) ax=0;

            if(ai==0) ax=1;
            Eda[ai]->Text=ax;
        }
    }else{
        for(int ai=0;ai<10;ai++){
            double ax=rand()%100;
            if(rand()%2==1) ax/=rand()%100+1;
            if(rand()%2==1) ax=-ax;
            if(rand()%2==1) ax=0;

            if(ai==0) ax=1;
            if(ai==5) ax=0;
            Eda[ai]->Text=ax;
        }
    }
    Button1->OnClick(this);
    Update();

    double zd[8],alm2=1e-16;
    for(int xa=0;xa<8;xa++){
        if(Edfz[xa]->Text=="") zd[xa]=0;
        else{
            zd[xa]=Edfz[xa]->Text.ToDouble();
            zd[xa]=zd[xa]*zd[xa];
        }
    }


    if(zd[0]<alm2&&zd[1]<alm2&&zd[2]<alm2&&zd[3]<alm2&&
        zd[4]<alm2&&zd[5]<alm2&&zd[6]<alm2&&zd[7]<alm2) continue;

    if(CheckBox1->Checked){
    fprintf(op,("\n\nf(x) = "+Edita0r->Text+" + "
                        +Edita1r->Text+"z + "
                        +Edita2r->Text+"z^2 + "
                        +Edita3r->Text+"z^3 + "
                        +Edita4r->Text+"z^4 = 0").c_str());
    }else{
        fprintf(op,("\n\nf(x) = ("+Edita0r->Text+" + "+Edita0i->Text + "i) + ("
                        +Edita1r->Text+" + "+Edita1i->Text + "i)z + ("
                        +Edita2r->Text+" + "+Edita2i->Text + "i)z^2 + ("
                        +Edita3r->Text+" + "+Edita3i->Text + "i)z^3 + ("
                        +Edita4r->Text+" + "+Edita4i->Text + "i)z^4 = 0").c_str());
    }

    fprintf(op,("\nz1 = "+Editz1r->Text+" +- "+Editz1i->Text).c_str());
    fprintf(op,("\nz2 = "+Editz2r->Text+" +- "+Editz2i->Text).c_str());
    fprintf(op,("\nz3 = "+Editz3r->Text+" +- "+Editz3i->Text).c_str());
    fprintf(op,("\nz4 = "+Editz4r->Text+" +- "+Editz4i->Text).c_str());

    fprintf(op,("\nf(z1) = "+Editfz1r->Text+" +- "+Editfz1i->Text).c_str());
    fprintf(op,("\nf(z2) = "+Editfz2r->Text+" +- "+Editfz2i->Text).c_str());
    fprintf(op,("\nf(z3) = "+Editfz3r->Text+" +- "+Editfz3i->Text).c_str());
    fprintf(op,("\nf(z4) = "+Editfz4r->Text+" +- "+Editfz4i->Text).c_str());
    }
    fclose(op);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
	double s[10];
	for(int i=0;i<10;i++){
    	if(Eda[i]->Text=="") s[i]=0;
    	else s[i]=Eda[i]->Text.ToDouble();
    }

	for(int i=3;i>=0;i--){
        s[i+1]=(4-i)*s[i];
        s[i+6]=(4-i)*s[i+5];
    }
    s[0]=0;
    s[5]=0;

	for(int i=0;i<10;i++){
    	if(s[i]==0) Eda[i]->Text="";
    	else Eda[i]->Text=AnsiString(s[i]);
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
	double s[10];
	for(int i=0;i<10;i++){
    	if(Eda[i]->Text=="") s[i]=0;
    	else s[i]=Eda[i]->Text.ToDouble();
    }

    if(s[0]!=0||s[5]!=0){
        Application->MessageBox("Please delete the coefficient of z^4.","Alert",MB_OK);
        return;
    }

	for(int i=0;i<4;i++){
        s[i]=s[i+1]/(4-i);
        s[i+5]=s[i+6]/(4-i);
    }
    s[4]=0;
    s[9]=0;

	for(int i=0;i<10;i++){
    	if(s[i]==0) Eda[i]->Text="";
    	else Eda[i]->Text=AnsiString(s[i]);
    }

}
//---------------------------------------------------------------------------


