#ifndef complexH
#define complexH
//---------------------------------------------------------------------------
class complex{
private:	// [U[錾
public:		// [U[錾
	double re,im;

	complex(double _rr=0, double _ii=0);
	friend complex ReIm(double _rr,double _ii);
	friend complex Polar(double _rr,double _tt);

	friend double real(complex z);
	friend double imag(complex z);

	friend complex operator +(complex a,complex b);
    friend complex operator +(complex a,double _tt);
    friend complex operator +(double _tt,complex a);
    friend complex operator -(complex a,complex b);
    friend complex operator -(complex a,double _tt);
    friend complex operator -(double _tt,complex a);
    friend complex operator *(complex a,complex b);
    friend complex operator *(complex a,double _tt);
    friend complex operator *(double _tt,complex a);
    friend complex operator /(complex a,complex b);
    friend complex operator /(complex a,double _tt);
    friend complex operator /(double _tt,complex a);
	friend bool operator ==(complex a,complex b);
    friend bool operator ==(complex a,double _tt);
    friend bool operator ==(double _tt,complex a);
	friend bool operator !=(complex a,complex b);
    friend bool operator !=(complex a,double _tt);
    friend bool operator !=(double _tt,complex a);

    complex operator =(double _tt);

    complex operator -();
    complex operator +=(complex a);
    complex operator +=(double _tt);
    complex operator -=(complex a);
    complex operator -=(double _tt);
    complex operator *=(complex a);
    complex operator *=(double _tt);
    complex operator /=(complex a);
    complex operator /=(double _tt);

	friend double cabs(complex z);
	friend double arg(complex z);
	friend double norm(complex z);
	friend complex conj(complex z);
 	friend complex exp (complex z);
 	friend complex log (complex z);
 	friend complex sqrt (complex z);
 	friend complex pow (complex z, double _tt);
 	friend complex pow (complex z, complex y);
 	friend complex pow (double _tt, complex z);
 	friend complex sin (complex z);
 	friend complex sinh (complex z);
 	friend complex cos (complex z);
 	friend complex cosh (complex z);
 	friend complex tan (complex z);
	friend complex tanh (complex z);
};
//---------------------------------------------------------------------------
#endif
